;**************************************************************************
;* FileName	: DUMMY819.ASM
;* Date 	: 25.08.2005
;* File version : v1.00
								list l=0
;* Author	: MIKO, Imre
;* Company	:
;* Homepage	: http://majki.fw.hu
;* E-mail	: majki@fw.hu
;*
;*-------------------------------------------------------------------------
;*
;* Description	: Dummy test
;*		  ==================================
;*		  Dummy test code.
;*
;*
;*-------------------------------------------------------------------------
;*
;* Connections	:	       ________	  ________
;*			      |        \_/	  |
;*		       n.c. ==| RA2	      RA1 |== n.c.
;*		       n.c. ==| RA3	      RA0 |== n.c.
;*		       n.c. ==| RA4      RA7/OSC1 |== quartz1
;*		     -reset ==|-MCLR/RA5 RA6/OSC2 |== quartz2
;*			GND ==| Vss	      Vdd |== +5V
;*		       n.c. ==| RB0	      RB7 |== n.c.
;*		       n.c. ==| RB1	      RB6 |== n.c.
;*		       n.c. ==| RB2	      RB5 |== n.c.
;*		       n.c. ==| RB3	      RB4 |== n.c.
;*			      |___________________|
;*				    PIC16F819
;*
;*-------------------------------------------------------------------------
;*
;* Resource	: Ports 	  :    xx /   16 pin   (   %)
;*		  Data memory	  :    xx /  256 byte  (   %)
;*		  Prog memory	  :   xxx / 2048 word  (   %)
;*		  EEPROM	  :    xx /  256 byte  (   %)
;*		  Timers	  : 
;*		  Interrupt	  : 
;*		  CCP		  :
;*		  SSP		  :
;*		  ADC		  :
;*
;**************************************************************************
;* Revision History:
;*
;* 1.00	  25/08/2005 	Initial Release
;*
;**************************************************************************

	list	p=16f819, r=dec, l=0

;***** INCLUDES ***********************************************************

	include "p16f819.inc"
	include "..\..\modules\base.inc"

;***** CONFIG ************************************************************

CFG_1	EQU 	_HS_OSC & _WDT_OFF & _PWRTE_ON & _MCLR_ON & _BODEN_ON & _LVP_OFF 
CFG_2	EQU	_CPD_OFF & _WRT_ENABLE_OFF & _DEBUG_OFF & _CCP1_RB2 & _CP_OFF


	__CONFIG CFG_1 & CFG_2
	__IDLOCS 0100h				; version

	EXPAND_MACROS	EXP_COND		; macro expansion mode
	MULTIPAGE	1, 2048, 4		; support for multipage program memory

;***** DEFINES ************************************************************
;#define DEBUG					; for some debug message
;#define NO_DELAY				; for fast simulation
;#define NO_RS232				; for fast simulation

xtal_freq	EQU	4 MHz	  		; crystal frequency
core_freq	EQU	xtal_freq/4		; core operating frequency


; ----- porta -------------------------------------------------------------

#define		PORTA_0		PORTA,0		; free
#define		PORTA_1		PORTA,1		; free
#define		PORTA_2		PORTA,2		; free
#define		PORTA_3		PORTA,3		; free
#define		PORTA_4		PORTA,4		; free (open drain)
#define		PORTA_5		PORTA,5		; free (only input or -MCLR!)
#define		PORTA_6		PORTA,6		; free (or OSC2)
#define		PORTA_7		PORTA,7		; free (or OSC1)

; ----- portb -------------------------------------------------------------

#define		MAX7456_SDIN	PORTB,0		; out
#define		MAX7456_SDOUT	PORTB,1		; in
#define		MAX7456_SCLK	PORTB,2		; out
#define		MAX7456_CS	PORTB,3		; out
#define		PORTB_4		PORTB,4		; free
#define		PORTB_5		PORTB,5		; free
#define		PORTB_6		PORTB,6		; free
#define		PORTB_7		PORTB,7		; free



;***** MACROS *************************************************************

	include "..\..\modules\math.mac"
	include "..\..\modules\wait.mac"
	include "..\..\modules\max7456.mac"


;***** CONSTANT DEFINITIONS ***********************************************

option_val	EQU	10000010b		; Timer source : intclk / 8
trisa_val	EQU	11111111b		; TRISA value (all input)
trisb_val	EQU	11111111b		; TRISB value (all input)
intcon_val	EQU	00100000b		; Interrupt control
adcon1_val	EQU	00000111b		; AD converter off


;***** VARIABLE DEFINITIONS ***********************************************
	cblock	70h				; common RAM
		icd_temp			; reserved for ICD
		w_temp				; variable used for context saving
		status_temp			; variable used for context saving
		fsr_temp			; variable used for context saving
	endc

;--------------------------------------------------------------------------
	cblock	1EBh
		icd_temp2:5			; reserved for ICD
	endc	

;--------------------------------------------------------------------------
	cblock	20h

		TEMP				; dummy register

	endc




;***** ENTRY POINT ********************************************************
		ORG	000h			; processor reset vector
		nop
		clrwdt
		clrf	STATUS
		goto	start


;***** IT HANDLER *********************************************************
;* Interrupt handler
;* <comment>
;**************************************************************************
		ORG	004h			; interrupt vector location
		movwf	w_temp			; save off current W register contents
		movf	STATUS,w		; move STATUS register into W register
		movwf	status_temp		; save off contents of STATUS register

		movf	FSR,w			; save FSR
		movwf	fsr_temp

;--------------------------------------------------------------------------
		clrf	STATUS			; bank 0

		; <IT Code>

;--------------------------------------------------------------------------
		movf	fsr_temp,w		; restore FSR
		movwf	FSR

		movf	status_temp,w		; retrieve copy of STATUS register
		movwf	STATUS			; restore pre-isr STATUS register contents
		swapf	w_temp,f
		swapf	w_temp,w		; restore pre-isr W register contents
		retfie				; return from interrupt




;***** REAL PROGRAM START *************************************************
start
;----- set configuration --------------------------------------------------
		clrf	PORTA			; clear latch
		clrf	PORTB			; clear latch

		bank1
		movlw	option_val
		movwf	LL OPTION_REG		; set OPTION_REG
		movlw	trisa_val
		movwf	LL TRISA		; set TRISA
		movlw	trisb_val
		movwf	LL TRISB		; set TRISB
		movlw	adcon1_val	
		movwf	LL ADCON1		; set ADCON1

		bank0
		movlw	intcon_val	
		movwf	INTCON			; set INTCON


;----- module init  -------------------------------------------------------

		MAX7456_INIT

		MAX7456_DEFCHAR 4Dh, char01    ; 



		MAX7456_PRINTCS "HELLO WORLD ()"

		MAX7456_GOTOXY	29,15

		MAX7456_MODE_INVERTED
		MAX7456_MODE_BLINKING

		movlw	'H'
		MAX7456_PRINTC



;----- main cycle  --------------------------------------------------------


main_cycle	nop

		; <code>

		goto	main_cycle




;--------------------------------------------------------------------------
char01		dt	01010101b, 01010100b, 00010101b		; 
		dt	01010101b, 01010010b, 10000101b
		dt	01010101b, 01001010b, 00010101b
		dt	01010101b, 00101000b, 01010101b
		dt	01010100b, 10101010b, 00010101b
		dt	01010010b, 10101010b, 10000101b
		dt	01001010b, 10000010b, 10100001b
		dt	00101010b, 00010100b, 10101000b
		dt	00101000b, 01010101b, 00101000b
		dt	00101000b, 01010101b, 00101000b
		dt	00101000b, 00000000b, 00101000b
		dt	00101010b, 10101010b, 10101000b
		dt	00101010b, 10101010b, 10101000b
		dt	00101000b, 00000000b, 00101000b
		dt	00101000b, 01010101b, 00101000b
		dt	00101000b, 01010101b, 00101000b
		dt	00101000b, 01010101b, 00101000b
		dt	01000001b, 01010101b, 01000001b








;***** INCLUDES ***********************************************************

	include "..\..\modules\max7456.inc"
	include "..\..\modules\wait.inc"
	include "..\..\modules\math.inc"

;**************************************************************************
	end				  	; end of program








